﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        int testForCount = 1000; //测试多少次
        int totalWeight = 0;    //总权重，做统计用
        int size = 5;   //一次随机抽取多少条记录

        /***** 初始化模拟权重数据 ************/
        List<Advert> list = new List<Advert>();
        list.Add(new Advert { Name = "A", Weight = 1 });
        list.Add(new Advert { Name = "B", Weight = 2 });
        list.Add(new Advert { Name = "C", Weight = 2 });
        list.Add(new Advert { Name = "D", Weight = 3 });
        list.Add(new Advert { Name = "E", Weight = 4 });
        list.Add(new Advert { Name = "F", Weight = 5 });
        list.Add(new Advert { Name = "G", Weight = 10 });

        
        for (int i = 0; i < list.Count; i++)
        {
            totalWeight += list[i].Weight;  //算总权重
        }

        Dictionary<string, int> dic = new Dictionary<string, int>();    //统计出现概率
        StringBuilder output = new StringBuilder(); //输出测试的内容
        //测试次数
        for (int i = 0; i < testForCount; i++)
        {
            //根据广告数量随机取出限制的条数
            List<Advert> ranList = RandomHelper.GetRandomList<Advert>(list, size);  //这个就是用法
            //统计随机的数量
            foreach (Advert item in ranList)
            {
                if (dic.ContainsKey(item.Name))
                {
                    dic[item.Name] += 1;
                }
                else
                {
                    dic.Add(item.Name, 1);
                }
                //output.Append(item.Title + " " + item.Weight + "<br />");
                output.Append(item.Name + " ");
            }
            output.Append("<hr/>");
        }
        output.Append("<table style='border:1px;'>");
        output.Append("<tr><th>名称</th><th>权重</th><th>权重比重</th><th>次数</th><th>出现概率</th></tr><br />");
        for (int i = 0; i < list.Count; i++)
        {
            int count = 0;
            if (dic.ContainsKey(list[i].Name))
            {
                count = dic[list[i].Name];
            }
            output.Append(string.Format("<tr><td>{0}</td><td>{1}</td><td>{2}</td><td>{3}</td><td>{4}</td></tr>"
                , list[i].Name, 
                list[i].Weight, 
                ((double)list[i].Weight / totalWeight).ToString("0.00%"), 
                count, 
                ((double)count / testForCount).ToString("0.00%")
                ));
        }
        output.Append("</table>");
        Response.Write(output.ToString());
    }

}

/// <summary>
/// 广告实体，务必继承RandomObject类
/// </summary>
public class Advert : RandomObject
{
    /// <summary>
    /// 广告名称
    /// </summary>
    public string Name{set;get;}
}